AP_Same = -1;
AP_Hero = -2;
AP_Hero_Half = -3;

GameConfig =
{
	ShakeCastleFactor = 2,
	
    DamageFlashFrames = 20,
    DamageFlashCycle = 5,
    DamageFlashAmp = 0.6,
    DamageFlashVar = 0.3,

    BossDamageFlashFrames = 20,
    BossDamageFlashCycle = 5,
    BossDamageFlashAmp = 0.4,
    BossDamageFlashVar = 0.2,
    BossDamageScreenFlashFrames = 15,
    
    WaterEffectSpeed = 2.0,
    HeatEffectSpeed = 0.10,
    HeatEffectAmount = 0.005,
    HeatEffectHeightOff = -0.2,

	LocationIntro = true,
	LocationIntroDisableControlsTime = 0.0, --1.0,

	GalleryCategoryNames =
	{
		"--",
		"gallery_category_illustrations",
		"gallery_category_characters",
		"gallery_category_dragons",
		"gallery_category_animations",
		"gallery_category_backgrounds",
		"gallery_category_backgrounds",
		"gallery_category_audio_sessions",
	},

	Monsters =
	{
	    -- AP, DP, HP
		{
			Easy = { AP=0, DP= 0, HP= 0  },
			Norm = { AP=0, DP= 0, HP= 0  },
			Hard = { AP=0, DP= 0, HP= 0  }
		},
		-- CYCLOPS 
		{
			Easy = { AP=32, DP= 48, HP= 256  },
			Norm = { AP=64, DP= 48, HP= 256  },
			Hard = { AP=64+32, DP= 48, HP= 256+256  }
		},
		{
			Easy = { AP=128, DP= 80, HP= 512  },
			Norm = { AP=160, DP= 80, HP= 512  },
			Hard = { AP=160+64, DP= 80, HP= 512+256  }
		},
		{
			Easy = { AP=180, DP= 128, HP= 768  },
			Norm = { AP=240, DP= 128, HP= 768  },
			Hard = { AP=240+10, DP= 128, HP= 768+512  }
		},
		-- WILL'O WISP
		{
			Easy = { AP=0, DP= 16, HP= 64  },
			Norm = { AP=0, DP= 16, HP= 64  },
			Hard = { AP=0, DP= 16, HP= 64+64  }
		},
		{
			Easy = { AP=32, DP= 16, HP= 192  },
			Norm = { AP=32, DP= 16, HP= 192  },
			Hard = { AP=32, DP= 16, HP= 192+64  }
		},
		{
			Easy = { AP=64, DP= 24, HP= 384  },
			Norm = { AP=64, DP= 24, HP= 384  },
			Hard = { AP=64, DP= 24, HP= 384+256  }
		},
		-- FALLING BLOCK
		{
			Easy = { AP=0, DP= 0, HP= 0  },
			Norm = { AP=0, DP= 0, HP= 0  },
			Hard = { AP=0, DP= 0, HP= 0  }
		},
		{
			Easy = { AP=0, DP= 0, HP= 0  },
			Norm = { AP=0, DP= 0, HP= 0  },
			Hard = { AP=0, DP= 0, HP= 0  }
		},
		-- BAT
		{
			Easy = { AP=0, DP= 16, HP= 128  },
			Norm = { AP=0, DP= 16, HP= 128  },
			Hard = { AP=0, DP= 16, HP= 128*2  }
		},
		{
			Easy = { AP=48, DP= 16, HP= 512  },
			Norm = { AP=48, DP= 16, HP= 512  },
			Hard = { AP=48, DP= 16, HP= 512*2  }
		},
		{
			Easy = { AP=128, DP= 16, HP= 1152  },
			Norm = { AP=128, DP= 16, HP= 1152  },
			Hard = { AP=128, DP= 16, HP= 1152*2  }
		},
		-- SKELETON
		{
			Easy = { AP=48, DP= 16, HP= 256  },
			Norm = { AP=48, DP= 16, HP= 256  },
			Hard = { AP=48, DP= 16, HP= 256*2  }
		},
		-- SKELETON MASTER
		{
			Easy = { AP=64, DP= 16, HP= 512  },
			Norm = { AP=64, DP= 16, HP= 512  },
			Hard = { AP=64, DP= 16, HP= 512*2  }
		},
		-- SKULL
		{
			Easy = { AP=32, DP= 16, HP= 128  },
			Norm = { AP=32, DP= 16, HP= 128  },
			Hard = { AP=32, DP= 16, HP= 128*2  }
		},
		-- SKULL MASTER
		{
			Easy = { AP=32, DP= 16, HP= 256  },
			Norm = { AP=32, DP= 16, HP= 256  },
			Hard = { AP=32, DP= 16, HP= 256*2  }
		},
		-- SKELETON HEADLESS
		{
			Easy = { AP=16, DP= 16, HP= 64  },
			Norm = { AP=16, DP= 16, HP= 64  },
			Hard = { AP=16, DP= 16, HP= 64*2  }
		},
		-- FLYING CYCLOPS
		{
			Easy = { AP=64, DP= 16, HP= 256  },
			Norm = { AP=64, DP= 16, HP= 256  },
			Hard = { AP=64, DP= 16, HP= 384  }
		},
		{
			Easy = { AP=112, DP= 32, HP= 512  },
			Norm = { AP=112, DP= 32, HP= 512  },
			Hard = { AP=112, DP= 32, HP= 512*2  }
		},
		{
			Easy = { AP=160, DP= 48, HP= 768  },
			Norm = { AP=160, DP= 48, HP= 768  },
			Hard = { AP=160, DP= 48, HP= 768*2  }
		},
		-- CRAB
		{
			Easy = { AP=0, DP= 0, HP= 64  },
			Norm = { AP=0, DP= 0, HP= 64  },
			Hard = { AP=0, DP= 0, HP= 64*2  }
		},
		{
			Easy = { AP=8, DP= 0, HP= 128  },
			Norm = { AP=16, DP= 0, HP= 144  },
			Hard = { AP=16, DP= 0, HP= 144*2  }
		},
		{
			Easy = { AP=16, DP= 0, HP= 192  },
			Norm = { AP=32, DP= 0, HP= 192  },
			Hard = { AP=32, DP= 0, HP= 192*2  }
		},
		-- TOAD
		{
			Easy = { AP=8, DP= 0, HP= 64  },
			Norm = { AP=16, DP= 0, HP= 64  },
			Hard = { AP=16, DP= 0, HP= 64*2  }
		},
		{
			Easy = { AP=16, DP= 0, HP= 128  },
			Norm = { AP=32, DP= 0, HP= 192  },
			Hard = { AP=32, DP= 0, HP= 192*2  }
		},
		{
			Easy = { AP=48, DP= 16, HP= 512  },
			Norm = { AP=64, DP= 16, HP= 512  },
			Hard = { AP=64, DP= 16, HP= 512*2  }
		},
		-- SHADOW
		{
			Easy = { AP=32, DP= 0, HP= 128  },
			Norm = { AP=48, DP= 0, HP= 128  },
			Hard = { AP=48, DP= 0, HP= 128*2  }
		},
		{
			Easy = { AP=64, DP= 0, HP= 512  },
			Norm = { AP=80, DP= 0, HP= 512  },
			Hard = { AP=80, DP= 0, HP= 512*2  }
		},
		{
			Easy = { AP=128, DP= 0, HP= 768  },
			Norm = { AP=160, DP= 0, HP= 768  },
			Hard = { AP=160, DP= 0, HP= 768*2  }
		},
		-- FAERIE
		{
			Easy = { AP=0, DP= 0, HP= 64  },
			Norm = { AP=0, DP= 0, HP= 64  },
			Hard = { AP=0, DP= 0, HP= 64*2  }
		},
		{
			Easy = { AP=32, DP= 0, HP= 256  },
			Norm = { AP=32, DP= 0, HP= 256  },
			Hard = { AP=32, DP= 0, HP= 256*2  }
		},
		{
			Easy = { AP=128, DP= 0, HP= 512  },
			Norm = { AP=128, DP= 0, HP= 512  },
			Hard = { AP=128, DP= 0, HP= 512*2  },
		},
		-- FUZZBALL
		{
			Easy = { AP=AP_Hero_Half, DP= 255, HP= 512 },
			Norm = { AP=AP_Hero, DP= 255, HP= 512 },
			Hard = { AP=AP_Hero, DP= 255, HP= 512*2 }
		},
		-- NINJA
		{
			Easy = { AP=160, DP= 0, HP= 512  },
			Norm = { AP=192, DP= 0, HP= 512  },
			Hard = { AP=192, DP= 0, HP= 512*2 }
		},
		{
			Easy = { AP=192, DP= 4, HP= 1024  },
			Norm = { AP=208, DP= 4, HP= 1024  },
			Hard = { AP=208, DP= 4, HP= 1024*2  }
		},
		{
			Easy = { AP=192, DP= 0, HP= 2048  },
			Norm = { AP=224, DP= 0, HP= 2048  },
			Hard = { AP=224, DP= 0, HP= 2048*2  }
		},
		-- SAMURAI
		{
			Easy = { AP=128, DP= 32, HP= 1024  },
			Norm = { AP=192-12, DP= 32, HP= 1024  },
			Hard = { AP=192, DP= 32, HP= 1024*2  }
		},
		{
			Easy = { AP=208-40, DP= 64, HP= 1024  },
			Norm = { AP=208-20, DP= 64, HP= 1024  },
			Hard = { AP=208, DP= 64, HP= 1024*2  }
		},
		{
			Easy = { AP=224-32, DP= 112-10, HP= 1024  },
			Norm = { AP=224-16, DP= 112, HP= 1024  },
			Hard = { AP=224, DP= 112, HP= 1024*2  }
		},
		-- OCTOPUS
		{
			Easy = { AP=0, DP= 0, HP= 64  },
			Norm = { AP=0, DP= 0, HP= 64  },
			Hard = { AP=0, DP= 0, HP= 64*2  }
		},
		{
			Easy = { AP=8, DP= 0, HP= 128  },
			Norm = { AP=16, DP= 0, HP= 128  },
			Hard = { AP=16, DP= 0, HP= 128*2  }
		},
		{
			Easy = { AP=48, DP= 0, HP= 192  },
			Norm = { AP=64, DP= 0, HP= 192  },
			Hard = { AP=64, DP= 0, HP= 192*2  }
		},
		-- HOVERING SMOG
		{
			Easy = { AP=0, DP= 0, HP= 16  },
			Norm = { AP=0, DP= 0, HP= 16  },
			Hard = { AP=0, DP= 0, HP= 16  }
		},
		{
			Easy = { AP=48, DP= 0, HP= 144  },
			Norm = { AP=48, DP= 0, HP= 144  },
			Hard = { AP=48, DP= 0, HP= 144*2  }
		},
		{
			Easy = { AP=96, DP= 0, HP= 320  },
			Norm = { AP=96, DP= 0, HP= 320  },
			Hard = { AP=96, DP= 0, HP= 320*2  }
		},
		-- ROPER
		{
			Easy = { AP=0, DP= 16, HP= 128  },
			Norm = { AP=0, DP= 16, HP= 128  },
			Hard = { AP=0, DP= 16, HP= 128*2  }
		},
		{
			Easy = { AP=32, DP= 16, HP= 384  },
			Norm = { AP=32, DP= 16, HP= 384  },
			Hard = { AP=32, DP= 16, HP= 384*2  }
		},
		{
			Easy = { AP=64, DP= 64, HP= 768  },
			Norm = { AP=64, DP= 64, HP= 768  },
			Hard = { AP=64, DP= 64, HP= 768*2  }
		},
		-- FISH
		{
			Easy = { AP=0, DP= 0, HP= 64  },
			Norm = { AP=0, DP= 0, HP= 64  },
			Hard = { AP=0, DP= 0, HP= 64*2  }
		},
		{
			Easy = { AP=16, DP= 16, HP= 128  },
			Norm = { AP=24, DP= 16, HP= 128  },
			Hard = { AP=24, DP= 16, HP= 128*2  }
		},
		{
			Easy = { AP=48, DP= 32, HP= 256  },
			Norm = { AP=64, DP= 32, HP= 256  },
			Hard = { AP=64, DP= 32, HP= 256*2  }
		},
		-- GOBLIN
		{
			Easy = { AP=48, DP= 48, HP= 128  },
			Norm = { AP=64, DP= 48, HP= 128  },
			Hard = { AP=64, DP= 48, HP= 128*2  }
		},
		{
			Easy = { AP=96, DP= 48, HP= 256  },
			Norm = { AP=128, DP= 48, HP= 256  },
			Hard = { AP=128, DP= 48, HP= 256*2  }
		},
		{
			Easy = { AP=150, DP= 80, HP= 512  },
			Norm = { AP=192, DP= 80, HP= 512  },
			Hard = { AP=192, DP= 80, HP= 512*2  }
		},
		-- SNAKE
		{
			Easy = { AP=0, DP= 0, HP= 64  },
			Norm = { AP=0, DP= 0, HP= 64  },
			Hard = { AP=0+16, DP= 0, HP= 64*2  }
		},
		{
			Easy = { AP=16, DP= 0, HP= 128  },
			Norm = { AP=16, DP= 0, HP= 128  },
			Hard = { AP=16+16, DP= 0, HP= 128*2  }
		},
		{
			Easy = { AP=128, DP= 0, HP= 512  },
			Norm = { AP=128, DP= 0, HP= 512  },
			Hard = { AP=128+64, DP= 0, HP= 512*2  }
		},
		-- MOVING BLOCK
		{
			Easy = { AP=64, DP= 0, HP= 0  },
			Norm = { AP=64, DP= 0, HP= 0  },
			Hard = { AP=64, DP= 0, HP= 0  }
		},
		-- FIRE ANT
		{
			Easy = { AP=0, DP= 16, HP= 64  },
			Norm = { AP=0, DP= 16, HP= 64  },
			Hard = { AP=0, DP= 16, HP= 64*2  }
		},
		{
			Easy = { AP=32, DP= 16, HP= 128  },
			Norm = { AP=32, DP= 16, HP= 128  },
			Hard = { AP=32, DP= 16, HP= 128*2  }
		},
		{
			Easy = { AP=64, DP= 16, HP= 256  },
			Norm = { AP=64, DP= 16, HP= 256  },
			Hard = { AP=64, DP= 16, HP= 256*2  }
		},
		-- SPARK
		{
			Easy = { AP=16, DP= 16, HP= 256  },
			Norm = { AP=16, DP= 16, HP= 256  },
			Hard = { AP=16, DP= 16, HP= 256*2  }
		},
		{
			Easy = { AP=32, DP= 16, HP= 512  },
			Norm = { AP=32, DP= 16, HP= 512  },
			Hard = { AP=32, DP= 16, HP= 512*2  }
		},
		{
			Easy = { AP=64, DP= 16, HP= 1024  },
			Norm = { AP=64, DP= 16, HP= 1024  },
			Hard = { AP=64, DP= 16, HP= 1024*1.5  }
		},
		-- FIRESTONE
		{
			Easy = { AP=32, DP= 255, HP= 4096, WpnAP=AP_Hero_Half },
			Norm = { AP=64, DP= 255, HP= 4096, WpnAP=AP_Hero },
			Hard = { AP=64, DP= 255, HP= 4096, WpnAP=AP_Hero }
		},
		{
			Easy = { AP=32, DP= 255, HP= 4096, WpnAP=AP_Hero_Half },
			Norm = { AP=64, DP= 255, HP= 4096, WpnAP=AP_Hero },
			Hard = { AP=64, DP= 255, HP= 4096, WpnAP=AP_Hero }
		},
		{
			Easy = { AP=32, DP= 255, HP= 4096, WpnAP=AP_Hero_Half },
			Norm = { AP=64, DP= 255, HP= 4096, WpnAP=AP_Hero },
			Hard = { AP=64, DP= 255, HP= 4096, WpnAP=AP_Hero }
		},
		{
			Easy = { AP=32, DP= 255, HP= 4096, WpnAP=AP_Hero_Half },
			Norm = { AP=64, DP= 255, HP= 4096, WpnAP=AP_Hero },
			Hard = { AP=64, DP= 255, HP= 4096, WpnAP=AP_Hero }
		},
		-- FLOWER LO
		{
			Easy = { AP=64, DP= 16, HP= 64, WpnAP=AP_Hero_Half },
			Norm = { AP=64, DP= 16, HP= 64, WpnAP=AP_Hero },
			Hard = { AP=64, DP= 16, HP= 64+128, WpnAP=AP_Hero },
		},
		-- FLOWER HI
		{
			Easy = { AP=64, DP= 16, HP= 64, WpnAP=AP_Hero_Half },
			Norm = { AP=64, DP= 16, HP= 64, WpnAP=AP_Hero },
			Hard = { AP=64, DP= 16, HP= 64+128, WpnAP=AP_Hero },
		},
		
		------------------------------------------------------------------------
		-- YELLOW MONSTERS
		------------------------------------------------------------------------

		-- SNAKE YELLOW
		{
			Easy = { AP=192, DP= 0, HP= 1024  },
			Norm = { AP=192, DP= 0, HP= 1024  },
			Hard = { AP=255, DP= 0, HP= 1024*2  }
		},
		-- NINJA YELLOW
		{
			Easy = { AP=235, DP= 0, HP= 4096  },
			Norm = { AP=235, DP= 0, HP= 4096  },
			Hard = { AP=235, DP= 0, HP= 4096*2  }
		},
		-- CYCLOPS YELLOW
		{
			Easy = { AP=255, DP= 160, HP= 1024  },
			Norm = { AP=255, DP= 160, HP= 1024  },
			Hard = { AP=255, DP= 160, HP= 1024  }
		},
		-- CRAB YELLOW
		{
			Easy = { AP=16, DP= 10, HP= 2000  },
			Norm = { AP=32, DP= 10, HP= 2000  },
			Hard = { AP=48, DP= 10, HP= 3000  }
		},
		-- TOAD YELLOW
		{
			Easy = { AP=48, DP= 16, HP= 1024  },
			Norm = { AP=64, DP= 16, HP= 1500  },
			Hard = { AP=64, DP= 16, HP= 1500  }
		},
		-- FAERIE YELLOW
		{
			Easy = { AP=64, DP= 20, HP= 1024  },
			Norm = { AP=64, DP= 20, HP= 1024  },
			Hard = { AP=128, DP= 20, HP= 1500  },
		},
		-- SHADOW YELLOW
		{
			Easy = { AP=196, DP= 0, HP= 1024  },
			Norm = { AP=196, DP= 0, HP= 1024  },
			Hard = { AP=220, DP= 0, HP= 2048  }
		},
		-- WILL'O WISP YELLOW
		{
			Easy = { AP=64, DP= 48, HP= 500  },
			Norm = { AP=64, DP= 48, HP= 500  },
			Hard = { AP=64, DP= 48, HP= 500  }
		},
		-- ROPER YELLOW
		{
			Easy = { AP=64, DP= 128, HP= 768  },
			Norm = { AP=64, DP= 128, HP= 768  },
			Hard = { AP=64, DP= 128, HP= 768*2  }
		},
		-- SPARK YELLOW
		{
			Easy = { AP=128, DP= 16, HP= 1024*1.5  },
			Norm = { AP=128, DP= 16, HP= 1024*1.5  },
			Hard = { AP=128, DP= 16, HP= 1024*2.0  }
		},
	},
	
	------------------------------------------------------------------------
	-- BOSSES
	------------------------------------------------------------------------

	Bosses =
	{
		-- MEKA
	    -- AP, DP, HP
		{
			Easy = { AP=214, DP= 200, HP= 1600, WpnAP=170  },
			Norm = { AP=255, DP= 221, HP= 1600, WpnAP=170  },
			Hard = { AP=255, DP= 250, HP= 1600, WpnAP=170  }
		},
		-- MUMMY
		{
			Easy = { AP=8, DP= 3, HP= 1600, WpnAP=5  },
			Norm = { AP=12, DP= 3, HP= 1600, WpnAP=8  },
			Hard = { AP=12, DP= 16, HP= 1600, WpnAP=8  }
		},
		-- ZOMBIE
		{
			Easy = { AP=68, DP= 84, HP= 1600, WpnAP=40  },
			Norm = { AP=68, DP= 84, HP= 1600, WpnAP=45  },
			Hard = { AP=68, DP= 84, HP= 1600, WpnAP=45  }
		},
		-- CAPTAIN
		{
			Easy = { AP=110, DP= 70, HP= 1600, WpnAP=87  },
			Norm = { AP=131, DP= 79, HP= 1600, WpnAP=87  },
			Hard = { AP=131, DP= 79, HP= 1600, WpnAP=87  },
		},
		-- DAIMYO
		{
			-- AP 241-0   w/ hero DP 132 -> hero -28 HP per hit [original]
			-- AP 241-10  w/ hero DP 132 -> hero -24 HP per hit
			-- AP 241-20  w/ hero DP 132 -> hero -20 HP per hit
			-- AP 241-50  w/ hero DP 132 -> hero -16 HP per hit
			-- AP 241-70  w/ hero DP 132 -> hero -8 HP per hit
			-- AP 241-100 w/ Hero DP 132 -> hero -4 HP per hit
			-- DP 179+00  w/ Hero AP 250 (Muramasa): ~ 24 HP per hit -> ~5 hits [original]
			-- DP 179+30  w/ Hero AP 250 (Muramasa): ~ 16 HP per hit -> ~6 hits
			-- DP 179+40  w/ Hero AP 250 (Muramasa): ~ 12 HP per hit -> ~8 hits
			Easy = { AP=214-70, DP= 179+30, HP= 1600, WpnAP=100  },
			Norm = { AP=214-65, DP= 179+40, HP= 1600, WpnAP=142  },
			Hard = { AP=214-35, DP= 179+40, HP= 1600, WpnAP=142  }
		},
		-- VAMPIRE
		{
			-- AP 255+255 w/ hero Legendary ~12,12 HP per hit, Wpn ~16
			-- AP 235+235 w/ hero Legendary ~12,12 HP per hit, Wpn ~12
			-- AP 220+220 w/ hero Legendary ~8,8
			Easy = { AP=180, DP= 150, HP= 1600, WpnAP=180  },
			Norm = { AP=215, DP= 170, HP= 1600, WpnAP=215  },
			Hard = { AP=235, DP= 170, HP= 1600, WpnAP=235  }
		},
	},
}
